import sys, traceback, Ice
Ice.loadSlice("Printer.ice")
import Demo

class PrinterI(Demo.Printer):  
	def printString(self, s, current=None):
		print("The string is : " + s)

	def getTest(self, current=None):
		return "String returned by getTest()"

	def getInfo(self, current=None):
		information = Demo.Info()
		return information

	def getMaster(self, current=None):
		adapter = self._adapter
		obj = MasterI()		
		objId = Ice.Identity()
		objId.name = Ice.generateUUID()
		self._adapter.add(obj, objId)
		objPrx = Demo.MasterPrx.uncheckedCast(self._adapter.createProxy(objId))
		return objPrx

class MasterI(Demo.Master):
	def getMasterString(self, current=None):
		return "String returned by getMasterString()"
		

class Server(Ice.Application):
	def run(self, args):
		if len(args) > 1:
			print(self.appName() + ": not allowed arguments")
			return 1

		adapter = self.communicator().createObjectAdapter("Printer.Server")
		adapter.add(PrinterI(), self.communicator().stringToIdentity("printer"))
		
		PrinterI._adapter = adapter

		adapter.activate()
		self.communicator().waitForShutdown()
		return 0

app = Server()
sys.exit(app.main(sys.argv, "config.server"))
		
